mvqtl_sampling_missing_marker <-
function(i,j,k,mk,mp,mkp1,mkp2,mfid){
  if(j==1){
    lc1=1
    lc2=2
  }else{
    lc1=j-1
    lc2=j
  }
  
  d <- mp[[i]][lc1]
  r <- cm2r(d,mfid)
  #r <- 0.5*(1-exp(-2*d*0.01))  # Haldane map fucntion
  
  p1 <- matrix(c(mkp1[[i]][1,lc1],mkp1[[i]][3,lc1],mkp1[[i]][1,lc2],
                 mkp1[[i]][3,lc2]),ncol=2,byrow=TRUE)
  p2 <- matrix(c(mkp2[[i]][1,lc1],mkp2[[i]][3,lc1],mkp2[[i]][1,lc2],
                 mkp2[[i]][3,lc2]),ncol=2,byrow=TRUE)
  
  trspb <- mvqtl_transprb(p1,p2,r)
  
  rnms <- rownames(trspb)
  cnms <- colnames(trspb)
  nr <- length(rnms)
  nc <- length(cnms)
  
  trs <- cbind(rep(0,nr),trspb)
  
  for(ii in 1:nc){
    trs[,ii+1] <- trs[,ii]+trs[,ii+1]
  }
  
  rdm <- runif(1)
  
  if(j==1){
    if(nr==2){
      if(rdm<0.5){ msmk="aa"}
      if(rdm>=0.5){ msmk="ab"}
    }
    
    if(nr==3){
      if(rdm<0.25){ msmk="aa"}
      if(rdm>=0.25 && rdm<0.75){ msmk="ab"}
      if(rdm>=0.75){ msmk="bb"}
    }
    
    if(nr==4){
      if(rdm<0.25){ msmk="ac"}
      if(rdm>=0.25 && rdm<0.5){ msmk="ad"}
      if(rdm>=0.5 && rdm<0.75){ msmk="bc"}
      if(rdm>=0.75){ msmk="bd"}
    }					
  }
  
  if(j>1){
    for(ii in 1:nr){
      if(mk[[i]][j-1,k]==rnms[ii]){
        for(jj in 1:nc)
          if(rdm>=trs[ii,jj] && rdm<trs[ii,jj+1]){
            msmk=cnms[jj]
          }
      }
    }
  }
  msmk
}
