\name{mvqtl_sampling_missing_marker}
\alias{mvqtl_sampling_missing_marker}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
supplement of the missing marker information
}
\description{
if there are missing marker datas, this function can help to supplement those missing data
}
\usage{
mvqtl_sampling_missing_marker(i, j, k, mk, mp, mkp1, mkp2, mfid)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{i}{
the marker information is a matrix, and i means the missing marker in row i 
}
  \item{j}{
j means the missing marker in column j  
}
  \item{k}{
nothing
}
  \item{mk}{
 information of the marker matrix
}
  \item{mp}{
genetic distance
}
  \item{mkp1}{
the genotype of parent 1
}
  \item{mkp2}{
the genotype of parent 2
}
  \item{mfid}{
ID of mapping function
}
}
\details{
nothing
\value{
nothing
}
\references{
nothing
}
\author{
%%  ~~who you are~~
}
\note{
nothing
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
nothing
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (i, j, k, mk, mp, mkp1, mkp2, mfid) 
{
    if (j == 1) {
        lc1 = 1
        lc2 = 2
    }
    else {
        lc1 = j - 1
        lc2 = j
    }
    d <- mp[[i]][lc1]
    r <- cm2r(d, mfid)
    p1 <- matrix(c(mkp1[[i]][1, lc1], mkp1[[i]][3, lc1], mkp1[[i]][1, 
        lc2], mkp1[[i]][3, lc2]), ncol = 2, byrow = TRUE)
    p2 <- matrix(c(mkp2[[i]][1, lc1], mkp2[[i]][3, lc1], mkp2[[i]][1, 
        lc2], mkp2[[i]][3, lc2]), ncol = 2, byrow = TRUE)
    trspb <- fscim_transprb(p1, p2, r)
    rnms <- rownames(trspb)
    cnms <- colnames(trspb)
    nr <- length(rnms)
    nc <- length(cnms)
    trs <- cbind(rep(0, nr), trspb)
    for (ii in 1:nc) {
        trs[, ii + 1] <- trs[, ii] + trs[, ii + 1]
    }
    rdm <- runif(1)
    if (j == 1) {
        if (nr == 2) {
            if (rdm < 0.5) {
                msmk = "aa"
            }
            if (rdm >= 0.5) {
                msmk = "ab"
            }
        }
        if (nr == 3) {
            if (rdm < 0.25) {
                msmk = "aa"
            }
            if (rdm >= 0.25 && rdm < 0.75) {
                msmk = "ab"
            }
            if (rdm >= 0.75) {
                msmk = "bb"
            }
        }
        if (nr == 4) {
            if (rdm < 0.25) {
                msmk = "ac"
            }
            if (rdm >= 0.25 && rdm < 0.5) {
                msmk = "ad"
            }
            if (rdm >= 0.5 && rdm < 0.75) {
                msmk = "bc"
            }
            if (rdm >= 0.75) {
                msmk = "bd"
            }
        }
    }
    if (j > 1) {
        for (ii in 1:nr) {
            if (mk[[i]][j - 1, k] == rnms[ii]) {
                for (jj in 1:nc) if (rdm >= trs[ii, jj] && rdm < 
                  trs[ii, jj + 1]) {
                  msmk = cnms[jj]
                }
            }
        }
    }
    msmk
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
