\name{mvqtlim_mapping}
\alias{mvqtlim_mapping}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
The function of  interval mapping
}
\description{
This function is interval mapping function and it can also be used to do permutation
}
\usage{
mvqtlim_mapping(lgi, mki, mkp1, mkp2, mk, mp, y, t, qtlmodeli, mfid, gdst, gmkdst, permu = 0)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{lgi}{
the number of linkage group
}
  \item{mki}{
the number of marker loci in the defined linkage group
}
  \item{mkp1}{
the genotype of parent 1
}
  \item{mkp2}{
the genotype of parent 2
}
  \item{mk}{
information of the marker matrix
}
  \item{mp}{
genetic distance
}
  \item{y}{
the information  of phenotype
}
  \item{t}{
the time points
}
  \item{qtlmodeli}{
the number of qtlmodel you want to map. 1~5 refers to QQ*Qq,Qq*QQ,Qq*Qq,qQ*Qq,q1q2*q3q4 respectively
}
  \item{mfid}{
this is the mapping function, 1 refers to Haldane and 2 refers to Kosambi
}
  \item{gdst}{
%%     ~~Describe \code{gdst} here~~
}
  \item{gmkdst}{
%%     ~~Describe \code{gmkdst} here~~
}
  \item{permu}{
this is to choose whether you want to do the permutation, and TRUE refers to do the permutation, FALSE refers to not,default=False 
}
}
\details{
nothing
}
\value{
nothing
}
\references{
nothing
}
\author{
%%  ~~who you are~~
}
\note{
nothing
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
nothing
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (lgi, mki, mkp1, mkp2, mk, mp, y, t, qtlmodeli, mfid, 
    gdst, gmkdst, permu = 0) 
{
    qtl_model <<- matrix(c("Q", "Q", "Q", "q", "Q", "q", "Q", 
        "Q", "Q", "q", "Q", "q", "Q", "q", "q", "Q", "q1", "q2", 
        "q3", "q4"), ncol = 4, byrow = TRUE)
    qtl <- qtl_model[qtlmodeli, ]
    n <- nrow(y)
    m <- ncol(y)
    nt <- ncol(y)
    p1 <- matrix(c(mkp1[[lgi]][1, mki], mkp1[[lgi]][3, mki], 
        qtl[1], qtl[2], mkp1[[lgi]][1, mki + 1], mkp1[[lgi]][3, 
            mki + 1]), ncol = 2, byrow = TRUE)
    p2 <- matrix(c(mkp2[[lgi]][1, mki], mkp2[[lgi]][3, mki], 
        qtl[3], qtl[4], mkp2[[lgi]][1, mki + 1], mkp2[[lgi]][3, 
            mki + 1]), ncol = 2, byrow = TRUE)
    d <- mp[[lgi]][mki]
    nd <- ceiling(d)
    if (qtlmodeli == 1 || qtlmodeli == 2) 
        nq = 2
    if (qtlmodeli == 3 || qtlmodeli == 4) 
        nq = 3
    if (qtlmodeli == 5) 
        nq = 4
    if (permu == 0) {
        itvrst <- matrix(0, nrow = nd, ncol = 8 + nt * nq)
    }
    else if (permu == 1) {
        itvrst <- matrix(0, nrow = nd, ncol = 3)
    }
    else {
        stop("Parameter error! permu=0 or 1 in QTL mapping")
    }
    my <- colMeans(y)
    dff <- y - rep(1, n) \%*\% t(my)
    sigma <- t(dff) \%*\% dff/n
    invS0 <- solve(sigma)
    lik0 <- -0.5 * n * m * (1 + log(2 * pi)) - 0.5 * n * log(det(sigma))
    for (d1 in 0.01:d) {
        cnpb <- mvqtl_conprb(p1, p2, d1, d, mfid)
        rwnms <- rownames(cnpb)
        clnms <- colnames(cnpb)
        nmk <- length(rwnms)
        p <- matrix(0, n, nq)
        for (i in 1:n) {
            gtpi <- paste(mk[[lgi]][mki, i], mk[[lgi]][mki + 
                1, i])
            for (j in 1:nmk) if (gtpi == rwnms[j]) {
                p[i, ] <- cnpb[j, ]
            }
        }
        mu1 <- matrix(0, m, nq)
        mu2 <- mu1
        for (i in 1:nq) {
            mu1[, i] <- my
        }
        P <- p
        invS1 <- invS0
        maxmu <- 1
        while (maxmu > 1e-06) {
            ydf <- y
            for (i in 1:n) {
                spf <- 0
                for (j in 1:nq) {
                  P[i, j] <- p[i, j] * mvqtl_mnord(y[i, ], mu1[, 
                    j], invS1)
                  spf <- spf + P[i, j]
                }
                for (j in 1:nq) {
                  P[i, j] <- P[i, j]/spf
                  ydf[i, ] <- ydf[i, ] - P[i, j] * mu1[, j]
                }
            }
            for (j in 1:nq) {
                mu2[, j] <- t(P[, j]) \%*\% y/sum(P[, j])
            }
            S <- matrix(0, m, m)
            for (i in 1:n) {
                for (j in 1:nq) {
                  S <- S + P[i, j] * cbind(c(y[i, ] - mu1[, j])) \%*\% 
                    c(y[i, ] - mu1[, j])
                }
            }
            S <- S/n
            invS1 <- solve(S)
            tmp <- mu1
            mu1 <- mu2
            mu2 <- tmp
            maxmu <- max(abs(mu1 - mu2))
        }
        lik <- 0
        for (i in 1:n) {
            spf <- 0
            for (j in 1:nq) {
                spf <- spf + p[i, j] * mvqtl_mnord(y[i, ], mu1[, 
                  j], invS1)
            }
            lik <- lik + log(spf)
        }
        LR <- 2 * (lik - lik0)
        if (permu == 0) {
            rstfnl <- c(lgi, mki, d1, round(gdst[lgi] + gmkdst[[lgi]][mki] + 
                d1, 2), round(lik0, 4), round(lik, 4), round(LR, 
                6), qtlmodeli)
            for (j in 1:nq) {
                rstfnl <- c(rstfnl, round(mu1[, j], 6))
            }
            itvrst[floor(d1) + 1, ] <- rstfnl
        }
        if (permu == 1) {
            rstfnl <- c(lgi, round(LR, 6), qtlmodeli)
            itvrst[floor(d1) + 1, ] <- rstfnl
        }
    }
    itvrst
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
