\name{mvqtlmap-package}
\alias{mvqtlmap-package}
\alias{mvqtlmap}
\docType{package}
\title{
Composite Interval Mapping or Interval Mapping of Quantitative
Trait Loci (QTL) in a full-sib family
}
\description{
\packageDescription{mvqtlmap}
}
\usage{
mvqtlmap(inputfile,method="CIM",qtlmodel=1:5,nbmk=15,winsize=10,mapfuncid=1,ifpermu=FALSE,permutimes=1000,np=1)
}
\arguments{
	\item{inputfile}{
		The text input file in a fixed format that contains linkage maps information ( 
		i.e. map distances and linkage phases),individual marker genotypes and the 
		multivariate phenotype data. Please see the manual for details.
	}
	\item{method}{
		The default method is composite interval mapping (CIM). One can choose 
		the interval mapping method (IM).
	}
	\item{qtlmodel}{
		The QTL model refers to the QTL segregation type, 1 for QQxQq, 2 for QqxQQ, 
		3 for QqxQq, 4 for QqxqQ and 5 for q1q2xq3q4.
	}
	\item{nbmk}{
	}
	\item{winsize}{
	}
	\item{mapfuncid}{
	}
	\item{ifpermu}{
	}
	\item{permutimes}{
	}
	\item{np}{
	}
}
	
\details{
\tabular{ll}{
Package: \tab mvqtlmap\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2016-05-3\cr
License: \tab What license is it under?\cr
}
cm2r()
mvqtl_backmks()\cr
mvqtl_conprb()\cr
mvqtl_conprb()\cr
mvqtl_readdata()\cr
mvqtl_regstepwise()\cr
mvqtl_sampling_missing_marker()\cr
mvqtl_transprb()\cr
mvqtlcim_mapping()\cr
mvqtlim_mapping()\cr
mvqtlLRPlot()\cr
mvqtlmap()\cr
}
\author{
\packageAuthor{mvqtlmap}

Maintainer: \packageMaintainer{mvqtlmap}
}
\references{

}
\keyword{ package }

\seealso{

}
\examples{
	mvqtlmap(inputfile="malev0.txt",qtlmodel=2)
}
